public inbox for netdev@vger.kernel.org
 help / color / mirror / Atom feed
* [PATCH] selftests/net: add test for IPv4-in-IPv6 tunneling
@ 2026-02-08 14:46 Linus Heckemann
  2026-02-09  0:56 ` Hangbin Liu
                   ` (2 more replies)
  0 siblings, 3 replies; 5+ messages in thread
From: Linus Heckemann @ 2026-02-08 14:46 UTC (permalink / raw)
  To: edumazet
  Cc: davem, eric.dumazet, horms, kuba, morikw2, netdev, pabeni,
	syzbot+d4dda070f833dc5dc89a, Linus Heckemann

81c734dae203757fb3c9eee6f9896386940776bd was fine in and of itself, but
its backport to 6.12 (and 6.6) broke IPv4-in-IPv6 tunneling, see [1].
This adds a self-test for basic IPv4-in-IPv6 functionality.

[1]: https://lore.kernel.org/all/CAA2RiuSnH_2xc+-W6EnFEG00XjS-dszMq61JEvRjcGS31CBw=g@mail.gmail.com/
---
 tools/testing/selftests/net/Makefile      |  1 +
 tools/testing/selftests/net/ip6_tunnel.sh | 41 +++++++++++++++++++++++
 2 files changed, 42 insertions(+)
 create mode 100644 tools/testing/selftests/net/ip6_tunnel.sh

diff --git a/tools/testing/selftests/net/Makefile b/tools/testing/selftests/net/Makefile
index 45c4ea381bc36..5037a344ad826 100644
--- a/tools/testing/selftests/net/Makefile
+++ b/tools/testing/selftests/net/Makefile
@@ -43,6 +43,7 @@ TEST_PROGS := \
 	io_uring_zerocopy_tx.sh \
 	ioam6.sh \
 	ip6_gre_headroom.sh \
+	ip6_tunnel.sh \
 	ip_defrag.sh \
 	ip_local_port_range.sh \
 	ipv6_flowlabel.sh \
diff --git a/tools/testing/selftests/net/ip6_tunnel.sh b/tools/testing/selftests/net/ip6_tunnel.sh
new file mode 100644
index 0000000000000..366f4c06cd6a3
--- /dev/null
+++ b/tools/testing/selftests/net/ip6_tunnel.sh
@@ -0,0 +1,41 @@
+#!/bin/bash
+# Test that IPv4-over-IPv6 tunneling works.
+
+set -e
+
+setup_prepare() {
+  ip link add transport1 type veth peer name transport2
+
+  ip netns add ns1
+  ip link set transport1 netns ns1
+  ip netns exec ns1 bash <<EOF
+  set -e
+  ip address add 2001:db8::1/64 dev transport1 nodad
+  ip link set transport1 up
+  ip link add link transport1 name tunnel1 type ip6tnl mode ipip6 local 2001:db8::1 remote 2001:db8::2
+  ip address add 172.0.0.1/32 peer 172.0.0.2/32 dev tunnel1
+  ip link set tunnel1 up
+EOF
+
+  ip netns add ns2
+  ip link set transport2 netns ns2
+  ip netns exec ns2 bash <<EOF
+  set -e
+  ip address add 2001:db8::2/64 dev transport2 nodad
+  ip link set transport2 up
+  ip link add link transport2 name tunnel2 type ip6tnl mode ipip6 local 2001:db8::2 remote 2001:db8::1
+  ip address add 172.0.0.2/32 peer 172.0.0.1/32 dev tunnel2
+  ip link set tunnel2 up
+EOF
+}
+
+cleanup() {
+  ip netns delete ns1
+  ip netns delete ns2
+  # in case the namespaces haven't been set up yet
+  ip link delete transport1
+}
+
+trap cleanup EXIT
+setup_prepare
+ip netns exec ns1 ping -W1 -c1 172.0.0.2
-- 
2.52.0


^ permalink raw reply related	[flat|nested] 5+ messages in thread

end of thread, other threads:[~2026-02-10 13:31 UTC | newest]

Thread overview: 5+ messages (download: mbox.gz follow: Atom feed
-- links below jump to the message on this page --
2026-02-08 14:46 [PATCH] selftests/net: add test for IPv4-in-IPv6 tunneling Linus Heckemann
2026-02-09  0:56 ` Hangbin Liu
2026-02-09 21:32 ` Ricardo B. Marlière
2026-02-09 22:19   ` Ricardo B. Marlière
2026-02-10 13:31 ` Ricardo B. Marlière

This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox